﻿Imports Infragistics.Controls.Charts
Imports System.Data
Imports System.Threading

Class MainWindow
    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()
        BuildGraph(fcMainChart)

    End Sub


    Public Sub BuildGraph(ByRef DataChart As XamDataChart)
        Dim CurCulture As String
        CurCulture = System.Threading.Thread.CurrentThread.CurrentCulture.ToString

        DataChart.Series.Clear()

        For i As Integer = 0 To 2
            Dim table As DataTable = CreateTable(10)
            Dim data = From row In table.Rows.OfType(Of DataRow)() Select New DateDataItem() With {.Date = CDate(row("Date")), .Value1 = CDbl(row("MAPE"))}

            Dim lSeries As New LineSeries
            MainXAxis.DateTimeMemberPath = "Date"
            lSeries.XAxis = MainXAxis
            lSeries.YAxis = MainYAxis
            lSeries.Title = "Series " & i
            lSeries.Legend = TitleLegend
            lSeries.ItemsSource = data 'ds.Tables(0)
            lSeries.ValueMemberPath = "Value1"

            Dim minVal As Date = table.Rows(0).Item("Date")
            Dim maxVal As Date = table.Rows(table.Rows.Count - 1).Item("Date")
            Dim axisRange As TimeSpan = maxVal - minVal

            With MainXAxis
                .DataContext = data
                .MinimumValue = minVal
                .MaximumValue = maxVal
                .LabelSettings.Angle = 45
                .Label = "{Date:T}"
            End With

            fcMainChart.Series.Add(lSeries)

        Next


    End Sub

    Public Function CreateTable(rows As Integer) As DataTable
        Dim d As New DataTable()
        Dim r As New Random()

        'Just to get three different random lines - otherwise series 1 & 2 match
        Thread.Sleep(100)


        Dim tDate As Date = Now
        d.Columns.Add(New DataColumn("Date", GetType(DateTime)))
        d.Columns.Add(New DataColumn("MAPE", GetType(Integer)))


        For i As Integer = 0 To rows
            Dim row As DataRow = d.NewRow()

            row("Date") = tDate.AddHours(i)
            row("MAPE") = r.[Next](1000 * i)
            d.Rows.Add(row)
        Next



        Return d
    End Function

    Private Sub LineSeries1VisibilityClick(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim chb As CheckBox = TryCast(sender, CheckBox)
        If chb IsNot Nothing AndAlso chb.IsChecked IsNot Nothing Then
            fcMainChart.Series(0).Opacity = If(chb.IsChecked.Value, 1, 0)
        End If
    End Sub

End Class



Public Class DateDataItem
    Public Property [Date]() As Date
        Get
            Return m_Date
        End Get
        Set(value As Date)
            m_Date = value
        End Set
    End Property
    Private m_Date As Date
    Public Property Value1() As Double
        Get
            Return m_Value1
        End Get
        Set(value As Double)
            m_Value1 = value
        End Set
    End Property
    Private m_Value1 As Double

End Class
